const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const referral_programs = sequelize.define(
    'referral_programs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

commission_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

validity_days: {
        type: DataTypes.INTEGER,
      
      

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  referral_programs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









































    db.referral_programs.hasMany(db.referral_links, {
      as: 'referral_links_program',
      foreignKey: {
          name: 'programId',
      },
      constraints: false,
    });




//end loop



    db.referral_programs.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.referral_programs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.referral_programs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return referral_programs;
};


